from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int

Process_Radtags_V0_1_0 = CommandToolBuilder(tool="process_radtags", base_command=["process_radtags"], inputs=[ToolInput(tag="in_inline_null", input_type=Boolean(optional=True), prefix="--inline-null", doc=InputDocumentation(doc=":   barcode is inline with sequence, occurs only on single-end read (default).")), ToolInput(tag="in_index_null", input_type=Boolean(optional=True), prefix="--index-null", doc=InputDocumentation(doc=":    barcode is provded in FASTQ header (Illumina i5 or i7 read).")), ToolInput(tag="in_null_index", input_type=Boolean(optional=True), prefix="--null-index", doc=InputDocumentation(doc=":    barcode is provded in FASTQ header (Illumina i7 read if both i5 and i7 read are provided).")), ToolInput(tag="in_inline_inline", input_type=Boolean(optional=True), prefix="--inline-inline", doc=InputDocumentation(doc=": barcode is inline with sequence, occurs on single and paired-end read.")), ToolInput(tag="in_index_index", input_type=Boolean(optional=True), prefix="--index-index", doc=InputDocumentation(doc=":   barcode is provded in FASTQ header (Illumina i5 and i7 reads).")), ToolInput(tag="in_inline_index", input_type=Boolean(optional=True), prefix="--inline-index", doc=InputDocumentation(doc=":  barcode is inline with sequence on single-end read and occurs in FASTQ header (from either i5 or i7 read).")), ToolInput(tag="in_index_inline", input_type=Boolean(optional=True), prefix="--index-inline", doc=InputDocumentation(doc=":  barcode occurs in FASTQ header (Illumina i5 or i7 read) and is inline with single-end sequence (for single-end data) on paired-end read (for paired-end data).")), ToolInput(tag="in_renz_one", input_type=Int(optional=True), prefix="--renz-1", doc=InputDocumentation(doc=": provide the restriction enzyme used (cut site occurs on single-end read)")), ToolInput(tag="in_renz_two", input_type=Int(optional=True), prefix="--renz-2", doc=InputDocumentation(doc=": if a double digest was used, provide the second restriction enzyme used (cut site occurs on the paired-end read).")), ToolInput(tag="in_best_rad", input_type=Boolean(optional=True), prefix="--bestrad", doc=InputDocumentation(doc=": library was generated using BestRAD, check for restriction enzyme on either read and potentially tranpose reads.")), ToolInput(tag="in_adapter_one", input_type=Int(optional=True), prefix="--adapter-1", doc=InputDocumentation(doc=": provide adaptor sequence that may occur on the single-end read for filtering.")), ToolInput(tag="in_adapter_two", input_type=Int(optional=True), prefix="--adapter-2", doc=InputDocumentation(doc=": provide adaptor sequence that may occur on the paired-read for filtering.")), ToolInput(tag="in_adapter_mm", input_type=Int(optional=True), prefix="--adapter-mm", doc=InputDocumentation(doc=": number of mismatches allowed in the adapter sequence.")), ToolInput(tag="in_retain_header", input_type=Boolean(optional=True), prefix="--retain-header", doc=InputDocumentation(doc=": retain unmodified FASTQ headers in the output.")), ToolInput(tag="in_merge", input_type=Boolean(optional=True), prefix="--merge", doc=InputDocumentation(doc=": if no barcodes are specified, merge all input files into a single output file.")), ToolInput(tag="in_filter_illumina", input_type=Boolean(optional=True), prefix="--filter-illumina", doc=InputDocumentation(doc=": discard reads that have been marked by Illumina's chastity/purity filter as failing.")), ToolInput(tag="in_disable_rad_check", input_type=Boolean(optional=True), prefix="--disable-rad-check", doc=InputDocumentation(doc=": disable checking if the RAD site is intact.")), ToolInput(tag="in_len_limit", input_type=Int(optional=True), prefix="--len-limit", doc=InputDocumentation(doc=": specify a minimum sequence length (useful if your data has already been trimmed).")), ToolInput(tag="in_barcode_dist_one", input_type=Boolean(optional=True), prefix="--barcode-dist-1", doc=InputDocumentation(doc=": the number of allowed mismatches when rescuing single-end barcodes (default 1).")), ToolInput(tag="in_barcode_dist_two", input_type=Boolean(optional=True), prefix="--barcode-dist-2", doc=InputDocumentation(doc=": the number of allowed mismatches when rescuing paired-end barcodes (defaults to --barcode-dist-1)."))], outputs=[], container="quay.io/biocontainers/stacks:2.55--he513fc3_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Process_Radtags_V0_1_0().translate("wdl")

